<?php

add_action("widgets_init", array('CuteGigsLatest', 'register'));


class CuteGigsLatest extends WP_Widget {

	function register() { 

		register_widget("CuteGigsLatest");

	}

	function CuteGigsLatest() {

		$widget_ops = array('classname' => 'CuteGigsLatest', 'description' => 'Displays the first upcoming gig.' );

		$this->WP_Widget('CuteGigsLatest', ' CG Upcoming Gig', $widget_ops);

	}

	function update($new_instance, $old_instance) { 

		$instance = $old_instance;

		$instance['title'] = $new_instance['title'];
		$instance['url'] = $new_instance['url'];

		return $instance;

	}

	function form($instance) { 

		$instance = wp_parse_args( (array) $instance, array( 'title' => 'Upcoming Gig', 'url' => '#' ) );

		$title = $instance['title'];
		$url = $instance['url'];

		?>

		<p>

			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Widget Title:'); ?> </label>
			<input type="text" id="<?php echo $this->get_field_id('title'); ?>" class="widefat" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo attribute_escape($title); ?>">
			
			<label for="<?php echo $this->get_field_id('url'); ?>"><?php _e('Link URL:'); ?> </label>
			<input type="text" id="<?php echo $this->get_field_id('url'); ?>" class="widefat" name="<?php echo $this->get_field_name('url'); ?>" value="<?php echo attribute_escape($url); ?>">

		</p>

		<?php

	}

	function widget($args, $instance){
		global $wpdb; 
		
		$uploads = wp_upload_dir();
		$baseurl = $uploads['baseurl'];
		
		$gig = $wpdb->get_row("SELECT poster FROM ".$wpdb->prefix."cutegigs WHERE date >= CURRENT_DATE ORDER BY date ASC LIMIT 1");
		
		if($gig) { 
			echo $args['before_widget'];
	
			$title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
	
			if (!empty($title)) {
	
				echo '<h3 class="widget-title">' . $title . '</h3>';
	
			} 
			
			echo '<div class="textwidget cutegigs_widget">';
			echo '<p align="center">';
			echo '<a target="_blank" href="'.esc_attr($instance['url']).'"><img alt="" src="'.$baseurl.'/posters/sides/'.esc_attr($gig->poster).'" width="'.cutegigs_SIDE_WIDTH.'"></a>';
			echo '</p>';
			echo '</div>';
	
			echo $args['after_widget'];
		}

	}

}


?>